function countLeadingSpaces(line) {
    const matches = line.match(/^(\s*\│\s*)*/);
    if (!matches)
        return 0;
    return matches[0].length;
}
export function parseInput(input) {
    var _a, _b;
    const lines = input.split('\n').filter((line) => line.trim());
    const tree = [];
    const stack = [];
    for (let i = 0; i < lines.length; i++) {
        const line = lines[i];
        if (line === '.')
            continue;
        const level = countLeadingSpaces(line);
        const normalizedLine = line.split('─').slice(-1)[0].trimStart();
        const [_, name, extra = ''] = (_a = normalizedLine.match(/^(.*?)(?:\s*\/\/\s*(.*))?$/)) !== null && _a !== void 0 ? _a : [];
        const nextLine = lines[i + 1] || '';
        const nextLineLevel = countLeadingSpaces(nextLine);
        const type = nextLineLevel > level ? 'directory' : 'file';
        const item = type === 'directory'
            ? { type, name, files: [], extra }
            : { type, name, extra };
        while (stack.length > 0 && stack[stack.length - 1].level >= level) {
            stack.pop();
        }
        if (stack.length === 0) {
            tree.push(item);
        }
        else {
            const parentItem = stack[stack.length - 1].item;
            (_b = parentItem.files) === null || _b === void 0 ? void 0 : _b.push(item);
        }
        if (item.type === 'directory') {
            stack.push({ level, item });
        }
    }
    return tree;
}
